function MPRC_CreateConfig()

	local VERTICAL_SPACE_BETWEEN_ELEMENTS = 15

	-- panel
	local MPRCConfigFrame = CreateFrame('Frame', 'MPRCConfigFrame', InterfaceOptionsFramePanelContainer)
	MPRCConfigFrame:Hide()
	MPRCConfigFrame.name = "Mythic Plus Run Calc"
	InterfaceOptions_AddCategory(MPRCConfigFrame)

	-- title
	local TitleLabel = MPRCConfigFrame:CreateFontString(nil, 'ARTWORK', 'GameFontNormalLarge')
	TitleLabel:SetPoint('TOPLEFT', MPRCConfigFrame, 'TOPLEFT', 16, -16)
	TitleLabel:SetText("Mythic PLus Run Calc")

	-- version
	local VersionLabel = MPRCConfigFrame:CreateFontString(nil, 'ARTWORK', 'GameFontNormalSmall')
	VersionLabel:SetPoint('BOTTOMLEFT', TitleLabel, 'BOTTOMRIGHT', 8, 0)
	VersionLabel:SetText('v' .. "0.1")

	-- author
	local AuthorLabel = MPRCConfigFrame:CreateFontString(nil, 'ARTWORK', 'GameFontNormalSmall')
	AuthorLabel:SetPoint('TOPRIGHT', MPRCConfigFrame, 'TOPRIGHT', -16, -24)
	AuthorLabel:SetText('Author: ' .. "Thies")

	-- 35 trait tracking
	MPRC_ENABLE_35_Checkbox = CreateFrame('CheckButton', 'BRH_HIDE_AFTER_ZONE', MPRCConfigFrame, 'InterfaceOptionsCheckButtonTemplate')
	MPRC_ENABLE_35_Checkbox:SetPoint('TOPLEFT', TitleLabel, 'BOTTOMLEFT', 0, -VERTICAL_SPACE_BETWEEN_ELEMENTS)
	MPRC_ENABLE_35_Checkbox:SetChecked(MPRC_ENABLE_35)

	local MPRC_ENABLE_35Label = MPRC_ENABLE_35_Checkbox:CreateFontString(nil, 'ARTWORK', 'GameFontHighlight')
	MPRC_ENABLE_35Label:SetPoint('LEFT', MPRC_ENABLE_35_Checkbox, 'RIGHT', 0, 0)
	MPRC_ENABLE_35Label:SetText('Enable 35th trait tracking')

	-- 54 trait tracking
	MPRC_ENABLE_54_Checkbox = CreateFrame('CheckButton', 'BRH_HIDE_AFTER_ZONE', MPRCConfigFrame, 'InterfaceOptionsCheckButtonTemplate')
	MPRC_ENABLE_54_Checkbox:SetPoint('TOPLEFT', MPRC_ENABLE_35_Checkbox, 'BOTTOMLEFT', 0, -VERTICAL_SPACE_BETWEEN_ELEMENTS)
	MPRC_ENABLE_54_Checkbox:SetChecked(MPRC_ENABLE_54)

	local MPRC_ENABLE_54Label = MPRC_ENABLE_54_Checkbox:CreateFontString(nil, 'ARTWORK', 'GameFontHighlight')
	MPRC_ENABLE_54Label:SetPoint('LEFT', MPRC_ENABLE_54_Checkbox, 'RIGHT', 0, 0)
	MPRC_ENABLE_54Label:SetText('Enable 54th trait tracking')

	-- footnote
	-- local CautionLabel = MPRCConfigFrame:CreateFontString(nil, 'ARTWORK', 'GameFontNormal')
	-- CautionLabel:SetPoint('BOTTOM', MPRCConfigFrame, 'BOTTOM', 0, 48)
	-- CautionLabel:SetText('')
	-- CautionLabel:SetWidth(325)
	-- CautionLabel:SetWordWrap(true)

	-- OnShow 
	MPRCConfigFrame:SetScript('OnShow', function(frame)
		MPRC_ENABLE_35_Checkbox:SetChecked(MPRC_ENABLE_35)
		MPRC_ENABLE_54_Checkbox:SetChecked(MPRC_ENABLE_54)
	end)

	-- Okay Action
	function MPRCConfigFrame.okay(arg1, arg2, arg3, ...)
		MPRC_ENABLE_35 = MPRC_ENABLE_35_Checkbox:GetChecked()
		MPRC_ENABLE_54 = MPRC_ENABLE_54_Checkbox:GetChecked()
	end

end