-- AP rank cost
AP_COST     = {}
AP_COST[1]  = 0
AP_COST[2]  = 100
AP_COST[3]  = 400
AP_COST[4]  = 725
AP_COST[5]  = 1075
AP_COST[6]  = 1450
AP_COST[7]  = 1850
AP_COST[8]  = 2275
AP_COST[9]  = 2725
AP_COST[10] = 3250
AP_COST[11] = 3875
AP_COST[12] = 4625
AP_COST[13] = 5500
AP_COST[14] = 6500
AP_COST[15] = 13340
AP_COST[16] = 22170
AP_COST[17] = 33450
AP_COST[18] = 47850
AP_COST[19] = 66470
AP_COST[20] = 90470
AP_COST[21] = 121070
AP_COST[22] = 160590
AP_COST[23] = 211470
AP_COST[24] = 276270
AP_COST[25] = 358770
AP_COST[26] = 464050
AP_COST[27] = 602700
AP_COST[28] = 785480
AP_COST[29] = 1026350
AP_COST[30] = 1341870
AP_COST[31] = 1759520
AP_COST[32] = 2305520
AP_COST[33] = 3023720
AP_COST[34] = 3970380
AP_COST[35] = 5216220
AP_COST[36] = 6851330
AP_COST[37] = 8766330
AP_COST[38] = 10776330
AP_COST[39] = 12886330
AP_COST[40] = 15101330
AP_COST[41] = 17426330
AP_COST[42] = 19866330
AP_COST[43] = 22426330
AP_COST[44] = 25116330
AP_COST[45] = 27941330
AP_COST[46] = 30906330
AP_COST[47] = 34021330
AP_COST[48] = 37291330
AP_COST[49] = 40726330
AP_COST[50] = 44331330
AP_COST[51] = 48116330
AP_COST[52] = 52091330
AP_COST[53] = 56266330
AP_COST[54] = 60651330
AP_COST[55] = 65256330

-- AK rank multiplier
AP_MULT     = {}
AP_MULT[0]  = 1
AP_MULT[1]  = 1.25
AP_MULT[2]  = 1.5
AP_MULT[3]  = 1.9
AP_MULT[4]  = 2.4
AP_MULT[5]  = 3
AP_MULT[6]  = 3.75
AP_MULT[7]  = 4.75
AP_MULT[8]  = 6
AP_MULT[9]  = 7.5
AP_MULT[10] = 9.5
AP_MULT[11] = 12
AP_MULT[12] = 15
AP_MULT[13] = 18.75
AP_MULT[14] = 23.5
AP_MULT[15] = 29.5
AP_MULT[16] = 37
AP_MULT[17] = 46.5
AP_MULT[18] = 58
AP_MULT[19] = 73
AP_MULT[20] = 91
AP_MULT[21] = 114
AP_MULT[22] = 143
AP_MULT[23] = 179
AP_MULT[24] = 224
AP_MULT[25] = 250

-- format ints to include commas
function comma_value(amount)
  local formatted = amount
  while true do  
    formatted, k = string.gsub(formatted, "^(-?%d+)(%d%d%d)", '%1,%2')
    if (k==0) then
      break
    end
  end
  return formatted
end

SLASH_MAWCOUNTER1, SLASH_MAWCOUNTER2 = '/mcalc', '/mcount';

function SlashCmdList.MAWCOUNTER(msg, editbox)

  -- check for non max level toons to prevent error
  if MC_TOTALAK == nil then
    print("No AK detected");
    return
  end

  -- calcs
  local toParagon   = AP_COST[36] - MC_TOTALAP
  local toFinish    = AP_COST[55] - MC_TOTALAP
  local percentPara = math.floor(100 * MC_TOTALAP/AP_COST[36])
  local percentDone = math.floor(100 * MC_TOTALAP/AP_COST[55])  
  local totalFormat = comma_value(MC_TOTALAP)
  local ParaFormat  = comma_value(AP_COST[36])
  local finalFormat = comma_value(AP_COST[55])

  local m2award  = AP_MULT[MC_TOTALAK] * 500 
  local m4award  = AP_MULT[MC_TOTALAK] * 800
  local m7award  = AP_MULT[MC_TOTALAK] * 1000 
  local m10award = AP_MULT[MC_TOTALAK] * 1200

  local m2RunsToPara  = math.ceil(toParagon/m2award)
  local m4RunsToPara  = math.ceil(toParagon/m4award)
  local m7RunsToPara  = math.ceil(toParagon/m7award)
  local m10RunsToPara = math.ceil(toParagon/m10award)

  local m2RunsToFinish  = math.ceil(toFinish/m2award)
  local m4RunsToFinish  = math.ceil(toFinish/m4award)
  local m7RunsToFinish  = math.ceil(toFinish/m7award)
  local m10RunsToFinish = math.ceil(toFinish/m10award)

  if MPRC_ENABLE_35 == true then
    -- output for 1st bonus trait
    if percentPara < 100 then
      print("|cffff573335th trait progress")
      print(totalFormat ..  "/" .. ParaFormat)
      print(percentPara .. "% Complete")
      print("M+ 2-3 needed: " .. m2RunsToPara)
      print("M+ 4-6 needed: " .. m4RunsToPara)
      print("M+ 7-9 needed: " .. m7RunsToPara)
      print("M+ 10+ needed: " .. m10RunsToPara)
    else
      print("|cff52ff3335th Trait - Completed")
    end
  end 

  if MPRC_ENABLE_54 == true then
    -- output for finishing weapon
    if percentDone < 100 then
      print("|cffff5733Total weapon progress")
      print(totalFormat .. "/" .. finalFormat)
      print(percentDone .. "% Complete")
      print("M+ 2-3 needed: " .. m2RunsToFinish)
      print("M+ 4-6 needed: " .. m4RunsToFinish)
      print("M+ 7-9 needed: " .. m7RunsToFinish)
      print("M+ 10+ needed: " .. m10RunsToFinish)
    else
      print("|cff52ff3354th Trait - Completed")
    end
  end

  if MPRC_ENABLE_35 == false and MPRC_ENABLE_54 == false then
    print("No mythic plus run tracking enabled")
  end
end

-- setup frame to refresh AP and AK when the weapon is updated
local MawCounter_Frame = CreateFrame("FRAME", "MawCounter");
MawCounter_Frame:RegisterEvent("ARTIFACT_UPDATE");

local function eventHandler(self, event, ...)
   
    local rank    = C_ArtifactUI.GetTotalPurchasedRanks()
    local spent   = AP_COST[rank+1]
    local current = C_ArtifactUI.GetPointsRemaining()
    
    MC_TOTALAP = spent + current
    MC_TOTALAK = C_ArtifactUI.GetArtifactKnowledgeLevel()
    
end

MawCounter_Frame:SetScript("OnEvent", eventHandler);

local function Initialize(self, event, addonName, ...)   
    if addonName == 'MythicPlusRunCalc' then 

        if MPRC_ENABLE_35 == nil then
            MPRC_ENABLE_35 = true
        end

        if MPRC_ENABLE_54 == nil then
            MPRC_ENABLE_54 = true
        end

        MPRC_CreateConfig()      
    end
end

--Initialize()
MPRC_LoadedFrame = CreateFrame('Frame')
MPRC_LoadedFrame:SetScript('OnEvent', Initialize)
MPRC_LoadedFrame:RegisterEvent('ADDON_LOADED')
